Summary:	The GNU core utilities: a set of tools commonly used in shell scripts
Name:		coreutils
Version:	8.21
%define subrel	1
Release:	%mkrel 6
License:	GPLv3+
Group:		System/Base
Url:		http://www.gnu.org/software/coreutils/
Source0:	http://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.xz

# fileutils
Patch101:	coreutils-8.2-spacedir.patch
Patch1155:	coreutils-8.17-force-option--override--interactive-option.patch
Patch118:	fileutils-8.17-ls_h.patch
Patch500:	coreutils-8.3-mem.patch

# add --color option to md5sum and shaXsum
Patch201:	coreutils-8.21-sum-color.patch

# sh-utils

#add info about TZ envvar to date manpage
Patch703:	coreutils-8.21-dateman.patch
Patch713:	coreutils-4.5.3-langinfo.patch

# (sb) lin18nux/lsb compliance - normally from here:
# http://www.openi18n.org/subgroups/utildev/patch/
# this one is actually a merger of 5.2 and 5.3, as join segfaults
# compiled with gcc4 and the 5.1/5.2 patch
# fwang: we often get this patch from fedora
Patch800:	coreutils-8.21-new-i18n.patch

Patch909:	coreutils-5.1.0-64bit-fixes.patch

# https://qa.mandriva.com/show_bug.cgi?id=38577
Patch911:	coreutils-8.3-groupfix.patch

Patch1011:	coreutils-8.15-DIR_COLORS-mdkconf.patch
#(peroyvind): add back always red blinking on broken symlinks
Patch1013:	coreutils-8.2-always-blinking-colors-on-broken-symlinks.patch
#(peroyvind): fix a test that fails to compile with -Werror=format-security
Patch1014:	coreutils-8.8-check-string-format.patch

# fedora patches
#add note about no difference between binary/text mode on Linux - md5sum manpage
Patch2101:	coreutils-8.9-manpages.patch
#temporarily workaround probable kernel issue with TCSADRAIN(#504798)
Patch2102:	coreutils-8.19-sttytcsadrain.patch
#do display processor type for uname -p/-i based on uname(2) syscall
Patch2103:	coreutils-8.2-uname-processortype.patch
#df --direct
Patch2104:	coreutils-8.21-df-direct.patch
#Fix mkstemp on sparc64
Patch2105:	coreutils-mkstemp.patch

#getgrouplist() patch from Ulrich Drepper.
Patch2908:	coreutils-getgrouplist.patch
#Prevent buffer overflow in who(1) (bug #158405).
Patch2912:	coreutils-overflow.patch

# from upstream git, ln -srf incorrectly updated symlink with relative path
Patch3003:	coreutils-8.20-ln-relative-symlink.patch
# from upstream via fedora, do proper cleanup when strip fails in install command
Patch3004:	coreutils-8.21-install-strip.patch

# more fixes from upstream git between coreutils 8.21 and 8.22
Patch3005:	coreutils-8.21-tail-retry-wait.patch
Patch3006:	coreutils-8.21-tail-retry-exit.patch
Patch3007:	coreutils-8.21-mkdir-acl-umask.patch
Patch3008:	coreutils-8.21-od-large-width.patch
Patch3009:	coreutils-8.21-df-unstatable-mount.patch
Patch3010:	coreutils-8.21-mv-empty-rmdir.patch
Patch3011:	coreutils-8.21-df-blocks-translation.patch
Patch3012:	coreutils-8.21-ls-recursive-exit-status.patch
Patch3013:	coreutils-8.21-rm-prompt-protected.patch
Patch3014:	coreutils-8.21-mktemp-p-tmpdir.patch
Patch3015:	coreutils-8.21-mktemp-quiet-io-errors.patch
Patch3016:	coreutils-8.21-mktemp-exit-status.patch
Patch3017:	coreutils-8.21-cp-no-preserve-error.patch
Patch3018:	coreutils-8.21-shred-direct-io.patch
Patch3019:	coreutils-8.21-shred-larger-chunks.patch
Patch3020:	coreutils-8.21-shred-last-write.patch
Patch3021:	coreutils-8.21-shred-block-size.patch
Patch3022:	coreutils-8.21-shred-empty-file.patch
Patch3023:	coreutils-8.21-sort-error-child.patch
Patch3024:	coreutils-8.21-timeout-kill-after.patch
Patch3025:	coreutils-8.21-tail-inotify-symlinks.patch
Patch3026:	coreutils-8.21-df-symlink-disk-device.patch
Patch3027:	coreutils-8.21-df-bind-mounts.patch

# upstream fix, post-8.22
Patch3028:	coreutils-8.21-date-tz-crash.patch

BuildRequires:	locales-fr
BuildRequires:	locales-ja
BuildRequires:	locales-zh
BuildRequires:	locales-tr
BuildRequires:	gettext
BuildRequires:	termcap-devel
BuildRequires:	pam-devel
BuildRequires:	texinfo >= 4.3
# We need automake which supports the dist-xz target
BuildRequires:	automake >= 1.10.2-2
# And tar which supports xz automagically since rpm.org seems to rely on this(..?)
BuildRequires:	tar >= 1.21-2
BuildRequires:	libacl-devel
BuildRequires:	libattr-devel
BuildRequires:	libgmp-devel
BuildRequires:	libcap-devel
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	strace
Requires(pre):	filesystem >= 2.1.9-18
Requires:	pam >= 0.66-12

Provides:	mktemp = %{version}
Obsoletes:	mktemp < %{version}

Provides:	stat = %{version}
Provides:	%{_bindir}/env
Provides:	/bin/env
Obsoletes:	base64
Conflicts:	tetex < 1.0.7-49
Conflicts:	util-linux < 2.23.1

%description
This package is the union of the old GNU fileutils, sh-utils, and
textutils packages.

These tools are the GNU versions of common useful and popular
file & text utilities which are used for:
- file management
- shell scripts
- modifying text file (spliting, joining, comparing, modifying, ...)

Most of these programs have significant advantages over their Unix
counterparts, such as greater speed, additional options, and fewer
arbitrary limits.

%package	doc
Summary:	Coreutils documentation in info format
Group:		Documentation
Requires:	coreutils >= 4.5.4-2
Requires(post,preun):	info-install
BuildArch:	noarch

%description	doc
This package contains coreutils documentation in GNU info format.

%prep
%setup -q

# fileutils
# (tpg) seems to be fixed
#patch101 -p1 -b .space~
%patch1155 -p1 -b .override~
%patch118 -p1

# textutils
%patch500 -p1

# sh-utils
%patch703 -p1 -b .dateman~
%patch713 -p1 -b .langinfo~

# li18nux/lsb
%patch800 -p1 -b .i18n~

%patch909 -p1 -b .64bit~
%patch911 -p1 -b .groups~

%patch1011 -p1 -b .colors_mdkconf~
%patch1013 -p1 -b .broken_blink~
%patch1014 -p1 -b .str_fmt~

%patch2101 -p1 -b .manpages~
%patch2102 -p1 -b .tcsadrain~
%patch2103 -p1 -b .sysinfo~
# (tpg) not needed for now
#patch2104 -p1 -b .dfdirect~
%patch2105 -p1 -b .sparc~

%patch2908 -p1 -b .getgrouplist~
%patch2912 -p1 -b .overflow~

%patch3003 -p1 -b .ln-relative-symlink
%patch3004 -p1 -b .strip

%patch3005 -p1 -b .tail-retry-wait
%patch3006 -p1 -b .tail-retry-exit
%patch3007 -p1 -b .mkdir-acl-umask
%patch3008 -p1 -b .od-large-width
%patch3009 -p1 -b .df-unstatable-mount
%patch3010 -p1 -b .mv-empty-rmdir
%patch3011 -p1 -b .df-blocks-translation
%patch3012 -p1 -b .ls-recursive-exit-status
%patch3013 -p1 -b .rm-prompt-protected
%patch3014 -p1 -b .mktemp-p-tmpdir
%patch3015 -p1 -b .mktemp-quiet-io-errors
%patch3016 -p1 -b .mktemp-exit-status
%patch3017 -p1 -b .cp-no-preserve-error
%patch3018 -p1 -b .shred-direct-io
%patch3019 -p1 -b .shred-larger-chunks
%patch3020 -p1 -b .shred-last-write
%patch3021 -p1 -b .shred-block-size
%patch3022 -p1 -b .shred-empty-file
%patch3023 -p1 -b .sort-error-child
%patch3024 -p1 -b .timeout-kill-after
%patch3025 -p1 -b .tail-inotify-symlinks
%patch3026 -p1 -b .df-symlink-disk-device
%patch3027 -p1 -b .df-bind-mounts
%patch3028 -p1 -b .date-tz-crash

%patch201 -p1 -b .color-sum

chmod a+x tests/misc/sort-mb-tests.sh tests/misc/id-context.sh
chmod +w ./src/dircolors.h
./src/dcgen ./src/dircolors.hin > ./src/dircolors.h

export DEFAULT_POSIX2_VERSION=199209
aclocal -I m4
automake --gnits --add-missing
autoconf
bzip2 -9 ChangeLog

%build
export CFLAGS="%{optflags} -fPIC -D_GNU_SOURCE=1"

%configure2_5x \
	--enable-largefile \
	--enable-pam \
	--enable-no-install-program=hostname,uptime,kill \
	--enable-install-program=arch \
	--without-selinux \
	--disable-rpath \
	--disable-silent-rules

%make

%check
#make check

%install
rm -rf %{buildroot}
%makeinstall_std

# man pages are not installed with make install
make mandir=%{buildroot}%{_mandir} install-man

# let be compatible with old fileutils, sh-utils and textutils packages :
mkdir -p %{buildroot}{%{_sbindir},%{_sysconfdir}/pam.d}

# chroot was in /usr/sbin :
mv %{buildroot}/{%{_bindir},%{_sbindir}}/chroot

install -m644 src/dircolors.hin -D %{buildroot}%{_sysconfdir}/DIR_COLORS

#TV# find_lang look for LC_MESSAGES, not LC_TIME:
#TV(cd %{buildroot}; find .%_datadir/locale/ -name coreutils.mo | fgrep LC_TIME | \
#TV	sed -e "s!^.*/share/locale/\([^/]*\)/!%lang(\1) %_datadir/locale/\1/!") >> %name.lang
find %{buildroot}%{_datadir}/locale/ -name coreutils.mo | fgrep LC_TIME | xargs rm -f

%find_lang %{name}

%preun doc
%_remove_install_info %{name}.info

%post doc
%_install_info %{name}.info
# The next true is needed: else, if there's a problem, the 
# package'll be installed 2 times because of trigger faillure
true

%files -f %{name}.lang
%config(noreplace) %{_sysconfdir}/D*
%doc README
%{_bindir}/*
%{_sbindir}/chroot
# This should really be in %_libdir since it is a library, but coreutils
# builds it using the _PROGRAMS automake primary to avoid libtool, and
# pkglibdir_PROGRAMS is not allowed by automake v1.11-373-g9ca6326
# (since programs should be in pkglibexecdir, and libraries in pkglibdir),
# hence it was put in libexecdir. This is not terribly important, so I
# let it be (note that moving it is not enough, the path is built into
# the stdbuf binary). - Anssi 2012-07
%dir %{_libexecdir}/coreutils
%{_libexecdir}/coreutils/libstdbuf.so

%files doc
%doc ABOUT-NLS ChangeLog.bz2 NEWS THANKS TODO
%{_infodir}/coreutils*
%{_mandir}/man*/*


%changelog
* Mon Jan 05 2015 luigiwalser <luigiwalser> 8.21-6.1.mga4
+ Revision: 808708
- add upstream patch to fix CVE-2014-9471

* Sat Dec 21 2013 luigiwalser <luigiwalser> 8.21-6.mga4
+ Revision: 559349
- update i18n patch (from fedora)
- add bugfixes from coreutils 8.22

* Sat Oct 19 2013 umeabot <umeabot> 8.21-5.mga4
+ Revision: 536374
- Mageia 4 Mass Rebuild

* Mon Sep 23 2013 blue_prawn <blue_prawn> 8.21-4.mga4
+ Revision: 484185
- fixed substraction with unsigned ints

* Mon Sep 23 2013 blue_prawn <blue_prawn> 8.21-3.mga4
+ Revision: 483699
- add --color option to md5sum and shaXsum

* Wed Jun 05 2013 colin <colin> 8.21-2.mga4
+ Revision: 437515
- Build the 'arch' tool (dropped from util-linux)

  + luigiwalser <luigiwalser>
    - 8.21
    - re-diff dateman patch
    - re-diff df-direct patch (from fedora)
    - remove patches upstreamed in 8.21 (3000-3002)
    - update i18n patch (from fedora)
    - add upstream patch (via fedora) to cleanup in install command when strip fails

* Thu May 02 2013 luigiwalser <luigiwalser> 8.20-5.mga3
+ Revision: 411987
- Add patches from upstream to fix three issues:
  - cp --no-preserve=mode incorrect exit status (gnu#13119)
  - seq not honoring the step value in some cases (gnu#13525)
  - ln -srf incorrectly updating a symlink with a relative path (gnu#14116)

* Wed May 01 2013 luigiwalser <luigiwalser> 8.20-4.mga3
+ Revision: 411789
- add upstream patch to remove spurious newline from seq -s output (mga#9940)

* Fri Feb 01 2013 luigiwalser <luigiwalser> 8.20-3.mga3
+ Revision: 393949
- update i18n patch from fedora to fix CVE-2013-022[1-3]

* Fri Jan 11 2013 umeabot <umeabot> 8.20-2.mga3
+ Revision: 348172
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Jan 05 2013 tmb <tmb> 8.20-1.mga3
+ Revision: 339424
- update to 8.20

* Fri Nov 09 2012 fwang <fwang> 8.19-2.mga3
+ Revision: 316579
- update rpm group

* Sat Sep 01 2012 tv <tv> 8.19-1.mga3
+ Revision: 287108
- new release
- su is dead (dropping associated patches)

* Fri Jul 27 2012 anssi <anssi> 8.17-3.mga3
+ Revision: 275003
- ls: fix coloring of relative symlinks in / so that they do not appear
  as broken (relative-symlink-in-root.patch from upstream git, regression
  of 8.17)
- fix libstdbuf.so location in filelist

* Sat Jul 21 2012 colin <colin> 8.17-2.mga3
+ Revision: 273158
- Update for usrmove

* Wed Jun 27 2012 tv <tv> 8.17-1.mga3
+ Revision: 264224
- new release
- rediff patches

* Mon Jun 04 2012 colin <colin> 8.15-2.mga3
+ Revision: 254041
- Add pam files for runuser[-l] (fixes calling runuser command - e.g. cyrus-imapd)

* Mon Mar 05 2012 tmb <tmb> 8.15-1.mga2
+ Revision: 219272
- drop buildroot and defattr

  + fwang <fwang>
    - new version 8.15

  + tv <tv>
    - new release
    - sync with mdv
    - disable patches 101 and 2104
    - rediff patches 800 1011 2101 2104

* Tue Jan 04 2011 tmb <tmb> 8.8-2.mga1
+ Revision: 128
- imported package coreutils

